#ifndef MASH_FCA_MGR_H
#define MASH_FCA_MGR_H


#include "srm/appmgr-srm.h"
#include "srm/session-srm.h"
#include "fca-rreq.h"

class FCAMgr;
class FCARcvr;

class FCAMgr : public SRM_AppMgr {
public:
  FCAMgr() : SRM_AppMgr(NULL), pSession_(NULL) {
    Debug(dbgFCA,("Creating FCA app-manager$$$$$$$$$$$$$$$$$$$$$$$$$"));
  }
  virtual ~FCAMgr() {}

  /* the following virtual functions are SRM callbacks */
  SRM_PacketHandler *new_source(const srm_src &sid, int islocal);
  int next_ADU(u_char *db, int len, srm_src &id, int &pkt_type,
	       int &next);
  int  periodic_update(u_char *pb);
  virtual void handle_SA(const srm_src &sid, u_char *pb, int len);
  virtual void handle_request(const srm_src &sid, u_char *pb, int len);
  virtual void handle_reply(const srm_src &sid, u_char *pb, int len);
  void sched_request(FCARepairRequest* pRequest, const SrcId& sid ) {
    pSession_->sched_request(pRequest, sid);
  }
  void sched_reply(FCARepairReply* pReply, const SrcId& sid) {
    pSession_->sched_reply(pReply, sid);
  }
 
  int FCAMgr::command(int argc, const char*const* argv);

private:
  FCARcvr *DefineRcvr(const srm_src &sid, int islocal);

  SRM_Session* pSession_;
};





class FCARcvr : public SRM_PacketHandler {
public:
    FCARcvr() : SRM_PacketHandler() { }
    virtual ~FCARcvr() { }
    virtual void recv(u_char *buf, int len);
};




#endif // MASH_FCA_MGR_H
