# Auxiliary files
source tcl/common/application.tcl
source tcl/common/dbg-err.tcl
source tcl/srm/cf-srm.tcl
source tcl/mb/debug.tcl
source tcl/mb/utils.tcl

# generic ato files
source tcl/atobj/application-atp.tcl
source tcl/atobj/anm-view.tcl
source tcl/atobj/datasrc.tcl
source tcl/atobj/datasrc-local.tcl
source tcl/atobj/anm-obj.tcl
source tcl/atobj/atobj-rcvr.tcl
source tcl/atobj/atobj-sm.tcl

# nam files
source tcl/atobj/anm-view-nam.tcl
source tcl/atobj/datasrc-nam.tcl
source tcl/atobj/nam-edge.tcl
source tcl/atobj/nam-node.tcl
source tcl/atobj/nam-pkt.tcl
source tcl/atobj/nam-network.tcl
source tcl/atobj/nam-ui.tcl

proc DbgOut { args } {     
        # return
        
        upvar self slf
        global mb
        if ![info exists slf] {
                puts $args
        } else {
                set class [$slf info class]
                if {[eval $class info vars nodbg_]!=""} {
                        return
                }
                puts "[$slf info class] $slf: $args"
        }
}

# classes with nodbg_ set will not display debug information
#
AnmView/Nam set nodbg_ 1
DataSrc/Local/Nam set nodbg_ 1
NamUI set nodbg_ 1
DataSrc/Nam set nodbg_ 1

proc DbgVar {args} {
        upvar self slf

        foreach v $args {
                upvar $v var
                if ![info exists slf] {
                        puts [concat $v "=" $var]
                } else {
                        set class [$slf info class]
                        if {[eval $class info vars nodbg_]!=""} {
                                return
                        }
                        if [info exists var] {
                                puts "[$slf info class]|$slf: $v=$var"
                        } else {
                                puts "[$slf info class]|$slf: $v not found!"
                        }
                }
        }
}

proc DbgAssert { bool } {
        if {!$bool} {
                puts "assert failed!"
                error "Assert failed!"
        }
}

proc main {argv} {    
        new ATP $argv
}

main $argv

