
import AnnounceListenManager/AS/Client/MeGa

#XXX making this class is a temporary hack
Class AnnounceListenManager/SAP/MeGa -superclass AnnounceListenManager/SAP

#
AnnounceListenManager/SAP/MeGa public init {s spec {mtu 2048} } {
    $self next $spec $mtu
    $self set s_ $s
}

#
AnnounceListenManager/SAP/MeGa private recv_announcement {args} {
    $self instvar s_
    eval $s_ recv $self $args
}

#XXX
AnnounceListenManager/SAP/MeGa private incrnsrcs {args} {}
AnnounceListenManager/SAP/MeGa private sample_size {args} {}
AnnounceListenManager/SAP/MeGa private interval {args} { return 0 }


# Receives program announcements via SAP and uses the MeGa
# architecture to receive announcements through a proxy.  (See
# <a href=http://www.cs.berkeley.edu/~elan/mega/>Elan's MeGa page</a>
# for more info about MeGa...)
Class ProgramSource/SAP/MeGa -superclass ProgramSource/SAP

# Initializes a new object.  Arguments have the same meaning as
# for ProgramSource/SAP::init but there can be only a single address
# rather than a list of them.
ProgramSource/SAP/MeGa public init {ui addr} {
    # need to do these things before calling next constructor
    $self set name_ "MeGa Proxy: $addr"
    set addr [intoa [lookup_host_addr $addr]]
    set d [$self get_option cachedir]
    if {$d != ""} {
	$self set cache_ [file join $d $addr]
    }

    eval $self next $ui

    $self instvar app_
    set app_ [Application instance]

    $self instvar bw_
    set bw_ [$app_ get_option megaBW]
    # use 2% of capacity for sdp gateway
    set bw [expr 0.02 * $bw_]

    set spec "$addr/60000:10002/1"
    $app_ add_default megaStartupWait 60
    set sname sdp:0:0:IN:IP4:224.2.127.254
    set sspec 224.2.127.254/9875/127
    $app_ add_default megaCtrl $spec
    set rportspec 10000:10002

    $self instvar al_
    set loc [$self get_option serviceLocation]
    set al_ [new AnnounceListenManager/AS/Client/MeGa $self \
		 $spec $bw Nsdr sdp $sname $sspec $rportspec null $loc]
    $al_ start
}

# Used to set the name of the tag for this program source in the
# user interface.
ProgramSource/SAP/MeGa public name {} {
    return [$self set name_]
}

# Invoked by MeGa to tell the object it should listen for SAP
# messages on the address/port given by <i>spec</i>.
ProgramSource/SAP/MeGa public reset_spec {spec} {
    set l [split $spec /]

    $self instvar addr_ sport_ rport_ ttl_
    set addr_ [lindex $l 0]
    set ports [split [lindex $l 1] :]
    set sport_ [lindex $ports 0]
    set rport_ [lindex $ports 1]
    set ttl_ [lindex $l 3]
    
    $self instvar addrs_
    foreach a $addrs_ {
	delete $a
    }
    set addrs_ {}
    set s $addr_/$sport_:$rport_/$ttl_
    lappend addrs_ [new AnnounceListenManager/SAP/MeGa $self $s]
}

ProgramSource/SAP/MeGa public scopes {} {
    #XXX
    return {}
}

#XXX should this stuff be in AnnounceListenManager/MeGa/Client ?
ProgramSource/SAP/MeGa instproc have_network {} {
    $self instvar addr_
    return [info exists addr_]
}

ProgramSource/SAP/MeGa instproc session-addr {} {
    $self instvar addr_
    return $addr_
}

ProgramSource/SAP/MeGa instproc session-sport {} {
    $self instvar sport_
    return $sport_
}

ProgramSource/SAP/MeGa instproc session-rport {} {
    $self instvar rport_
    return $rport_
}

ProgramSource/SAP/MeGa instproc session-ttl {} {
    $self instvar ttl_
    return $ttl_
}

