
import ProgramSource TCP/Client

#
Class ProgramSource/Proxy -superclass { ProgramSource TCP/Client }

# XXX spec shouldn't be necessary -- should do ERS
ProgramSource/Proxy public init {ui spec} {
    #XXX
    $self set name_ "Proxy: $spec"

    $self next $ui

    # make sure no client caching is performed
    $self instvar cache_
    catch {unset cache_}

    $self set buffer_ ""

    # XXX ERS goes here
    $self connect $spec
}

#
ProgramSource/Proxy public destroy {} {
    $self next
}

# Used to set the name of the tag for this program source in the
# user interface.
ProgramSource/Proxy public name {} {
    return [$self set name_]
}

# XXX
ProgramSource/Proxy public scopes {} {
    return {}
}

#
ProgramSource/Proxy private connect {spec} {
    # open tcp connection to the cache agent
    set l [split $spec /]
    set host [lindex $l 0]
    set port [lindex $l 1]
    $self open $host $port

    # ask the cache agent to send programs
    $self send "subscribe\n"
}

#
ProgramSource/Proxy public recv s {
    $self instvar buffer_
    append buffer_ "$s\n"

    # look for blank line
    if {[string trim $s] == ""} {
	set i [string wordend $buffer_ 0]
	set cmd [string trim [string range $buffer_ 0 $i]]
	set data [string trim [string range $buffer_ $i end]]

	switch $cmd {
	    "add" - "update" {
		$self next $data
	    }

	    "remove" {
		$self instvar progs_
		if ![info exists progs_($data)] {
		    $self warn "got remove for nonexistent prog \"$data\""
		} else {
		    $self remove $progs_($data)
		}
	    }

	    default {
		$self warn "got bogus command \"$cmd\""
	    }
	}

	set buffer_ ""
    }
}

ProgramSource/Proxy public announce {msg scope} {
    #XXX
}

#XXX need stop-announce
