
import AnnounceListenManager/GraphComm

Class ScSpatialCombiner

ScSpatialCombiner instproc init {id cntrl_spec} {
    $self next;

    $self instvar output_id_list_;
    $self instvar output_info_;

    $self instvar input_id_list_;
    $self instvar input_info_;

    $self instvar subgraph_list_;
    $self instvar subgraph_info_;

    $self instvar sid_;
    
    $self instvar id_;
    $self instvar comm_obj_;

    $self instvar callback_array_;

    set output_id_list_ "";
    set input_id_list_ "";

    set id_ $id;

    set comm_obj_ [new AnnounceListenManager/GraphComm [$self get_option mtu] $cntrl_spec];
    $comm_obj_ register $id_ "$self recv_graph_comm";

    set sid_ -1;
    set subgraph_list_ "";
}

ScSpatialCombiner instproc send_graph_comm {rid mesg} {
    $self instvar comm_obj_;
    $self instvar id_;
    
    $comm_obj_ do_announce $id_ $rid $mesg;
}

ScSpatialCombiner instproc send_to_subgraph {sid rid mesg {repeat_period 0} {deliver_once_flag 0}} {
    $self instvar subgraph_info_;
    $self instvar id_;

    set comm_obj $subgraph_info_($sid,comm_obj);
    $comm_obj do_announce $id_ $rid $mesg $repeat_period $deliver_once_flag;
}

ScSpatialCombiner instproc forward_response {orid sub mid mesg} {
    $self instvar subgraph_info_;

    set comm_obj $subgraph_info_($sub,comm_obj);
    $comm_obj stop_resend $mid;

    $self send_graph_comm $orid $mesg;
}

ScSpatialCombiner instproc set_input_spec {in_id spec} {
    $self instvar input_info_;
    $self instvar subgraph_list_;
    $self instvar subgraph_info_;

    if {$input_info_($in_id,spec) == $spec} {
	return;
    }

    set spec_split [split $spec "/"];

    set input_info_($in_id,spec) $spec;

    foreach s $subgraph_list_ {
#	$self send_to_subgraph $s -1 [list set_input_spec $in_id $spec] 1000 1;
	after 1000 $self send_to_subgraph $s -1 [list [list set_input_spec $in_id $input_info_($in_id,spec)]] 1000 1;

    }
}

ScSpatialCombiner instproc trigger {} {
    $self instvar subgraph_list_;

    foreach s $subgraph_list_ {
	$self send_to_subgraph $s -1 [list trigger];
    }
}

ScSpatialCombiner instproc set_output_spec {out_id spec} {
    eval $self instvar [$self info vars];

    if {$output_info_($out_id,spec) == $spec} {
	return;
    }
    
    set combiner_obj $output_info_($out_id,combiner_obj);

    set spec_split [split $spec "/"];
    
    set addr [lindex $spec_split 0];
    set port [lindex $spec_split 1];
    
    set output_info_($out_id,out_vagent) [new VideoAgent $self $addr/$port];
    $output_info_($out_id,out_vagent) local_bandwidth 30000000;

    $combiner_obj ssrc [$output_info_($out_id,out_vagent) get_local_srcid];
    $output_info_($out_id,bufferpool) srcid [$output_info_($out_id,out_vagent) get_local_srcid];
    $output_info_($out_id,encoder) target [$output_info_($out_id,out_vagent) get_transmitter];
}

ScSpatialCombiner instproc set_output_format {out_id format} {
    puts "Output format changes not dealt with yet!!!";
}

ScSpatialCombiner instproc set_output_geometry {out_id geometry} {
    puts "Output geometry changes not dealt with yet!!!!";
}

ScSpatialCombiner instproc set_all_output_geometries {geometry} {
    puts "Output geometry changes not dealt with yet!!!!";
}

ScSpatialCombiner instproc recv_subgraph_comm {sid rid mesg} {
    $self instvar callback_array_;

    if {[info exists callback_array_($sid,$rid)]} {
	set cb $callback_array_($sid,$rid);
	unset callback_array_($sid,$rid);
	eval $cb [list $mesg];
    }
}

ScSpatialCombiner instproc setup_inputs {sid req_id reply} {
    $self instvar subgraph_list_;
    $self instvar subgraph_info_;
    
    set comm_obj $subgraph_info_($sid,comm_obj);
    $comm_obj stop_resend $req_id;

    set in_list [lindex $reply 1];

    $self instvar input_id_list_;
    $self instvar input_info_;

    set input_id_list_ $in_list;

    foreach i $in_list {
	set input_info_($i,spec) "";
	set input_info_($i,trigger) 0;
    }
}

ScSpatialCombiner instproc setup_outputs {sid req_id reply} {
    $self instvar subgraph_list_;
    $self instvar subgraph_info_;
    $self instvar vagent_array_;

    set comm_obj $subgraph_info_($sid,comm_obj);
    $comm_obj stop_resend $req_id;

    set out_list [lindex $reply 1];

    $self instvar output_id_list_;
    $self instvar output_info_;

    set output_id_list_ $out_list;

    foreach o $output_id_list_ {
	set output_info_($o,spec) "";

	set spec [$self GenerateSpec];
	set spec_split [split $spec "/"];
	set addr [lindex $spec_split 0];
	set port [lindex $spec_split 1];

	set output_info_($o,combiner_obj) [new Module/Combine/Spatial/SC];
	set vagent_array_($addr,$port) [new ScSpatialCombinerVideoAgent $addr/$port $output_info_($o,combiner_obj)];
	set output_info_($o,vagent) $vagent_array_($addr,$port);
	set output_info_($o,in_spec) $addr/$port
	set output_info_($o,out_vagent) "";

	set output_info_($o,sc_decoder) [new Module/VideoDecoder/SCToSemicompressed];
	set output_info_($o,sc_buffer) [new VidRep/Semicompressed];
	$output_info_($o,sc_decoder) set_frame_buffer $output_info_($o,sc_buffer);
	set output_info_($o,encoder) [new Module/VideoEncoder/SemicompressedToJPEG];
	set output_info_($o,bufferpool) [new BufferPool/RTP];
	$output_info_($o,encoder) buffer-pool $output_info_($o,bufferpool);
	$output_info_($o,encoder) mtu [$self get_option mtu];
	
	$output_info_($o,sc_decoder) set_callback "$output_info_($o,encoder) recv $output_info_($o,sc_buffer)";

	$output_info_($o,combiner_obj) target $output_info_($o,sc_decoder);
	
	foreach s $subgraph_list_ {
	    # Create transmitting video agents in each subgraph and
	    # set spec accordingly

#	    $self send_to_subgraph $s -1 [list set_output_spec $o $addr/$port] 1000 1;
	    after 1000 $self send_to_subgraph $s -1 [list [list set_output_spec $o $output_info_($o,in_spec)]] 1000 1;	    
	}
    }
}

ScSpatialCombiner instproc recalculate_division {} {
    $self instvar subgraph_list_;
    $self instvar subgraph_info_;

    # For now, just do slices

    set num_subgraphs [llength $subgraph_list_];

    if {$num_subgraphs == 0} {
	return;
    }

    set num_subgraphs [expr $num_subgraphs*1.0];

    set x0 0.0;
    set x1 1.0;

    set cntr 0.0;
    foreach s $subgraph_list_ {
	set y0 [expr $cntr / $num_subgraphs];
	set cntr [expr $cntr + 1.0];
	set y1 [expr $cntr / $num_subgraphs];

	$self send_to_subgraph $s -1 [list set_output_geometry [list $x0 $y0 $x1 $y1]] 1000 1;
    }
}
	

ScSpatialCombiner instproc recv_graph_comm {rid mesg} {
    eval $self instvar [$self info vars];
    $self instvar callback_array_;
    
    set cmd [lindex $mesg 0];
    
    if {$subgraph_list_ == ""} {
	if {$cmd != "add_subgraph"} {
	    return;
	}
    }

    switch -exact -- $cmd {
	query_output_ids {
	    $self send_graph_comm $rid [list output_ids $output_id_list_];
	}
	query_output_info {
	    set out_id [lindex $mesg 1];
	    if {[lsearch $output_id_list_ $out_id] != -1} {
		$self send_graph_comm $rid [list output_info $out_id [list \
			[list spec $output_info_($out_id,spec)]]];
	    } else {
		$self send_graph_comm $rid [list output_info $out_id [list \
			[list error "No such output_id $out_id"]]];
	    }
	}
	query_input_ids {
	    $self send_graph_comm $rid [list input_ids $input_id_list_];
	}
	query_input_info {
	    set in_id [lindex $mesg 1];
	    if {[lsearch $input_id_list_ $in_id] != -1} {
		$self send_graph_comm $rid [list input_info $in_id [list \
			[list spec $input_info_($in_id,spec)] \
			[list trigger $input_info_($in_id,trigger)]]];
	    } else {
		$self send_graph_comm $rid [list input_info $in_id [list \
			[list error "No such input_id $in_id"]]];
	    }
	}
	query_parameter_ids {
	    puts "Doing query_parameter_ids"
	    set sub [lindex $subgraph_list_ 0];
	    set mid [$self send_to_subgraph $sub -1 "query_parameter_ids" 100];
	    set callback_array_($sub,$mid) "$self forward_response $rid $sub $mid "
	}
	query_parameter_info {
	    set pid [lindex $mesg 1];
	    set sub [lindex $subgraph_list_ 0];
	    set mid [$self send_to_subgraph $sub -1 "query_parameter_info $pid" 100];
	    set callback_array_($sub,$mid) "$self forward_response $rid $sub $mid "
	}
	set_parameter {
	    set pid [lindex $mesg 1];
	    set pval [lindex $mesg 2];
	    
	    foreach s $subgraph_list_ {
		$self send_to_subgraph $s -1 [list set_parameter $pid $pval];
	    }
	}
	set_input_spec {
	    set in_id [lindex $mesg 1];
	    set spec [lindex $mesg 2];
	    if {[lsearch $input_id_list_ $in_id] != -1} {
		$self set_input_spec $in_id $spec;
	    }
	}
	trigger {
	    $self trigger;
	}
	set_input_trigger {
	    set in_id [lindex $mesg 1];
	    set trigger_flag [lindex $mesg 2];
	    if {[lsearch $input_id_list_ $in_id] != -1} {
		if {$input_info_($in_id,trigger) != $trigger_flag} {
		    set input_info_($in_id,trigger) $trigger_flag;

		    foreach s $subgraph_list_ {
			$self send_to_subgraph $s -1 [list set_input_trigger $in_id $trigger_flag] 1000 1;
		    }
		}
	    }
	}
	set_output_spec {
	    set out_id [lindex $mesg 1];
	    set spec [lindex $mesg 2];
	    if {[lsearch $output_id_list_ $out_id] != -1} {
		$self set_output_spec $out_id $spec;
	    }
	}
	set_output_format {
	    set out_id [lindex $mesg 1];
	    set format [lindex $mesg 2];
	    if {[lsearch $output_id_list_ $out_id] != -1} {
		$self set_output_format $out_id $format;
	    }
	}
	set_output_geometry {
	    if {[llength $mesg] == 3} {
		set out_id [lindex $mesg 1];
		set geometry [lindex $mesg 2];
		if {[lsearch $output_id_list_ $out_id] != -1} {
		    $self set_output_geometry $out_id $geometry;
		}
	    } else {
		set geometry [lindex $mesg 2];
		$self set_all_output_geometries $geometry;
	    }
	}
	add_subgraph {
	    $self instvar subgraph_info_;
	    $self instvar callback_array_;

	    set new_subgraph [lindex $mesg 1];

	    foreach sid $subgraph_list_ {
		if {$subgraph_info_($sid,spec) == $new_subgraph} {
		    return;
		}
	    }

	    incr sid_;

	    lappend subgraph_list_ $sid_;
	    set subgraph_info_($sid_,comm_obj) [new AnnounceListenManager/GraphComm [$self get_option mtu] $new_subgraph];
	    $subgraph_info_($sid_,comm_obj) register $id_ "$self recv_subgraph_comm $sid_ ";
	    set subgraph_info_($sid_,spec) $new_subgraph;

	    if {[llength $subgraph_list_] == 1} {
		set output_id_request [$self send_to_subgraph $sid_ -1 "query_output_ids" 100];
		set callback_array_($sid_,$output_id_request) "$self setup_outputs $sid_ $output_id_request ";
		set input_id_request [$self send_to_subgraph $sid_ -1 "query_input_ids" 100];
		set callback_array_($sid_,$input_id_request) "$self setup_inputs $sid_ $input_id_request ";

	    } else {
		foreach o $output_id_list_ {
		    puts "after 1000 $self send_to_subgraph $sid_ -1 [list [list set_output_spec $o $output_info_($o,in_spec)]] 1000 1;"
		    after 1000 $self send_to_subgraph $sid_ -1 [list [list set_output_spec $o $output_info_($o,in_spec)]] 1000 1;
		}
		foreach i $input_id_list_ {
		    puts "after 1000 $self send_to_subgraph $sid_ -1 [list [list set_input_spec $i $input_info_($i,spec)]] 1000 1;"
		    after 1000 $self send_to_subgraph $sid_ -1 [list [list set_input_spec $i $input_info_($i,spec)]] 1000 1;
		}
		$self recalculate_division;
	    }
	}
	del_subgraph {
	    set subgraph_to_del [lindex $mesg 1];
	    
	    set sid_to_del "";
	    foreach s $subgraph_list_ {
		if {$subgraph_info_($s,spec) == $subgraph_to_del} {
		    set sid_to_del $s;
		}
	    }
	    if {$sid_to_del == ""} {
		return;
	    }
	    delete $subgraph_info_($sid_to_del,comm_obj);
	    unset subgraph_info_($sid_to_del,comm_obj);
	    unset subgraph_info_($sid_to_del,spec);

	    set idx [lsearch $subgraph_list_ $sid_to_del];
	    set subgraph_list_ [lreplace $subgraph_list_ $idx $idx];

	    $self recalculate_division;

	    if {$subgraph_list_ == ""} {
		# All the subgraphs are gone. 
		# XXX Need to handle this case.
	    }
	}
    }
}
    
ScSpatialCombiner instproc GenerateSpec {} {
    # OK, this is a REAL hack

    global spec_generator;

    if {![info exists spec_generator(init)]} {
	set spec_generator(init) 1;
	set spec_generator(b1) 224;
	set spec_generator(b2) 5;
	set spec_generator(b3) 9;
	set spec_generator(b4) 1;
	set spec_generator(port) 22334;
    }

    incr spec_generator(b4);

    return "$spec_generator(b1).$spec_generator(b2).$spec_generator(b3).$spec_generator(b4)/$spec_generator(port)/16";
}

import VideoAgent

Class ScSpatialCombinerVideoAgent -superclass VideoAgent

ScSpatialCombinerVideoAgent instproc init {spec combiner} {
    eval $self next $self $spec;

    $self instvar combiner_;

    set combiner_ $combiner;
}

ScSpatialCombinerVideoAgent instproc create_decoder src {
    $self instvar combiner_;

    set d [$src handler];
    if {$d != ""} {
	delete $d;
    }

    return $combiner_;
}

ScSpatialCombinerVideoAgent instproc deactivate src {
    puts "$src has been deactivated!!!!";
}

