proc ParseArgs {} {
    global argv;

    for {set i 0} {$i < [llength $argv]} {incr i} {
	if {[string compare [lindex $argv $i] "-subprogram"] == 0} {
	    incr i;
	    global subprogram;
	    set subprogram [lindex $argv $i];
	}
	if {[string compare [lindex $argv $i] "-num_nodes"] == 0} {
	    incr i;
	    global num_nodes;
	    set num_nodes [lindex $argv $i];
	}
    }
}

proc HandleRequest {sfd addr port} {
    global client_sock_fd;

    set client_sock_fd $sfd;
}

proc StartProc {my_addr my_port cmd args} {
    global client_sock_fd;
    global mash_bin tdemo_client 

    set client_sock_fd "";

    puts "Starting $cmd $args";
    flush stdout;

#    eval exec glurun $mash_bin $tdemo_client -- $my_addr $my_port $cmd $args >&/dev/null &;
    eval exec glurun $mash_bin $tdemo_client  $my_addr $my_port $cmd $args >& /dev/null &;
#    eval exec glurun $mash_bin $tdemo_client  $my_addr $my_port $cmd $args  &;

    while {$client_sock_fd == ""} {
	update;
    }

    set client_host [gets $client_sock_fd];

    puts "Client started on $client_host";

    global env node_spec;

    set node_spec "${node_spec}-${client_host}";
    set env(GLUNIX_NODES) $node_spec;

    global sock_list;

    lappend sock_list $client_sock_fd;
    set client_sock_fd "";
}


set port 30111;
set cntrl_spec 224.3.2.1/22334/16
set subprogram EdgeDetectSubprogram

set node_spec all
set num_nodes 2

set mash_dir $env(HOME)/mash-1-now/mash-1
set mash_bin $mash_dir/bin/smash;
set tselect $mash_dir/tcl/psvp/test/tselect.tcl
set tinter $mash_dir/tcl/psvp/test/tinter.tcl
set tproc $mash_dir/tcl/psvp/test/tproc.tcl
set tdemo_client $mash_dir/tcl/psvp/test/tdemo-client.tcl

set env(TCLCL_IMPORT) $env(HOME)/mash-1-now/mash-1:$env(HOME)/mash-1-now/mash-1/psvp/tcl:$env(HOME)/mash-1-now/mash-1/psvp/effects

cd $mash_dir;

ParseArgs;

set hname [exec hostname];

set habbr [lindex [split [string trim $hname] .] 0];

set env(GLUNIX_NODES) "${node_spec}-${habbr}";

set server_fd [socket -server HandleRequest $port];

StartProc $hname $port $tselect -cntrl_spec $cntrl_spec -comm_id ts;

StartProc $hname $port $tinter -cntrl_spec $cntrl_spec -comm_id ti;

for {set i 0} {$i < $num_nodes} {incr i} {
    StartProc $hname $port $tproc -reg_comm_spec $cntrl_spec -subprogram $subprogram
}

set argv "-cntrl_spec $cntrl_spec -comm_id ui";

source $mash_dir/tcl/psvp/test/basic-ui.tcl

