import RTPApplication

Class SubProgApp -superclass RTPApplication

SubProgApp instproc init args {
    $self next subprog_app

    $self init_resources;

    [$self options] register_option -subprogram subprogram
    [$self options] register_option -comm_id comm_id
    [$self options] register_option -cntrl_spec cntrl_spec
    [$self options] register_option -reg_comm_spec reg_comm_spec

    eval [$self options] parse_args $args;

    set subprog_type [$self get_option subprogram];

    uplevel #0 import $subprog_type;

    $self instvar subprog_obj_
    set subprog_obj_ [new $subprog_type [$self get_option comm_id] [$self get_option cntrl_spec]];

    $self instvar reg_comm_obj_;

    set reg_comm_obj_ [new AnnounceListenManager/GraphComm [$self get_option mtu] [$self get_option reg_comm_spec]];
    $reg_comm_obj_ register [$self get_option comm_id] "# ";
    $reg_comm_obj_ do_announce [$self get_option comm_id] -1 [list add_subgraph [$self get_option cntrl_spec]] 1000 1;
}

SubProgApp instproc init_resources {} {
    $self add_option network ip
    $self add_option mtu 1024
    $self add_option defaultTTL 32
    $self add_option sessionType rtpv2

    # Set up default cntrl_spec and comm_id

    set hname [exec hostname];
    set hname [split $hname .];
    set hname [string trim [lindex $hname 0]];
    
    $self add_option comm_id $hname;
    
    set hnum [string range $hname 1 end];
    $self add_option cntrl_spec 224.5.8.${hnum}/22334/16
    $self add_option maxVideoSessionBW 30000000
    
}

set app [new SubProgApp $argv];
